
(function ($) {

Drupal.modalFrameRegister = Drupal.modalFrameRegister || {};

/**
 * Opens Login and Register links in a Modal Frame.
 */
Drupal.behaviors.modalFrameRegister = function(context) {
  $('a.modalframe-register:not(.modalframe-register-processed)', context)
    
    // Now that we have matched an element, we add a CSS class, so that
    // we do not process the same element more than once.
    .addClass('modalframe-register-processed')

    // Now, we attach an onClick event handler to the element.
    .click(Drupal.modalFrameRegister.onClick);
};

/**
 * onClick event handler.
 */
Drupal.modalFrameRegister.onClick = function() {
  // Define the onSubmit callback for the Modal Frame.
  var onSubmitCallback = function(args) {
    if (args.redirect) {
      // Redirect to specified destination.
      setTimeout(function() { window.location = args.redirect; }, 1);
    }
    else {
       // Refresh the page after closing the modal window.
      location.reload();
    }
  };

  // The URL of the same link will be opened within a modal frame.
  Drupal.modalFrame.open({
    url: $(this).attr('href'),
    width: 500,
    height: 600,
    onSubmit: onSubmitCallback
  });

  // Return false so that we cancel the default link behavior.
  return false;
};

})(jQuery);
